<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: ChpassController.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Default
 * @copyright  Copyright (c) 2012 VEC
 */

class ChpassController extends Zend_Controller_Action
{
    
    public function indexAction()
    {
        $result['replyCode'] = 200;
        $translate = Zend_Registry::get('Zend_Translate');
        $form = $this->getForm();
        
        if(! $this->_request->isPost()) {
            $this->view->form = $form;
        } else {
            $form->populate($this->_request->getParams());
            
            if ($form->isValid($this->_request->getParams())) {
                
                $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();
                $users = new Giscuit_Db_Table_Users();
                $users->setPassword($userId, $form->getValue('password'));
                
                $result['result'] = $translate->_('passwordChanged');
            } else {
                $result['form'] = (string) $form;
            }
            
            $this->_helper->json($result);
        }
    }

    public function getForm ()
    {
        $form = new Giscuit_Form_Chpass();
        
        $action = $this->_helper->url->url(array(
            'language' => Zend_Registry::get('Zend_Translate')->getLocale() , 
            'module' => 'default' ,
            'controller' => 'chpass' ,
            'action' => 'index'
        ), null, true);
        $form->setAction($action);
        
        return $form;
    }

    
}