<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: LegendController.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Tool
 * @copyright  Copyright (c) 2012 VEC
 */

class Tool_LegendController extends Zend_Controller_Action
{
    public function indexAction()
    {
        $request = $this->getRequest();
                
        $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();
        
        $map = new Giscuit_Map_Map(GT_CONFIG_PATH . DIR_SEP . 'default.map');
        //Zend_Registry::set('map', $map);
        $map->setParamsFromConfig();

        //Legend specific
        $map->legendArr = array();
        $map->legend = true;
        
        if(! empty($userId)) {
            $mapOptions = Giscuit_Map_Map::getDefaultOptions();
            $mapOptions['orderDirection'] = 'asc';
        } else {
            $mapOptions = Giscuit_Map_Map::getPublishOptions();
        }
        
        $map->addCurrentLayers($mapOptions);
        
        if(! empty($userId)) {
            
        } else {
            $layers = explode(',', $request->getParam('layers'));
            
            //Get only requested layers
            foreach($map->legendArr as $key => $value) {
                if(! in_array($key, $layers)) {
                    unset($map->legendArr[$key]);
                }    
            }    
        }
                
        $this->view->legend = $map->legendArr;

    }

}