<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: BoolToChar.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Helper
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see  Zend_Controller_Action_Helper_Abstract
 */
require_once 'Zend/Controller/Action/Helper/Abstract.php';

/**
 * Convert a bool value to it's string equivalent
 * 
 * @category   Giscuit
 * @package    Giscuit_Helper
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Controller_Action_Helper_BoolToChar extends Zend_Controller_Action_Helper_Abstract
{

    /*
    public $pluginLoader;

    public function __construct()
    {
        $this->pluginLoader = new Zend_Loader_PluginLoader();
    }
    */
    
    /**
     * Convert a boolean value to it's string equivalent
     * 
     * @param string $item Value
     * @return string
     */
    public function boolToChar ($item)
    {
        if ($item == 'true') {
            return 't';
        } elseif ($item == 'false') {
            return 'f';
        }
    }

    /**
     * Strategy pattern: call helper as helper broker method
     * 
     * Convert a boolean value to it's string equivalent
     * 
     * @param string $item Value
     * @return string
     */
    public function direct ($item)
    {
        return $this->boolToChar($item);
    }
}