<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Plugin
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Controller_Plugin_Abstract
 */
require_once 'Zend/Controller/Plugin/Abstract.php';

/**
 * Plugin for data editing
 *  
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Plugin
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Controller_Plugin_Link extends Giscuit_Controller_Plugin_Abstract
{

    /**
     * Plugin display name
     * 
     * @var string
     */
    public static $label = 'Mark and share';
    
    /**
     * List of the javascript files to include
     * 
     * @return array
     */
    public function getJsFilesList ()
    {
        return array(
            'Control/Link.js' 
        );
    }
    
    /**
     * List of the javascript files to include for mobile
     * 
     * @return array
     */
    public function getMobileJsFilesList ()
    {
        return array(
            'Mobile/Control/Link.js'
        );
    }
    
    /**
     * Install plugin
     * 
     * @return boolean
     */
    public function install($newConfig) 
    {
        $rulesTable = new Giscuit_Db_Table_Rules();
        $data = array(
            'role' => 'guest',
            'resource' => 'default_link_controller',
            'privilege' => '',
            'group' => 'controller'
        );
        $rulesTable->insert($data);
    }
    
    /**
     * Uninstall plugin
     *  
     * @return boolean
     */
    public function uninstall($newConfig) 
    {
        $rulesTable = new Giscuit_Db_Table_Rules();
        $where = $rulesTable->getAdapter()->quoteInto('resource = ?', 'default_link_controller');
        $rulesTable->delete($where);
    }

}