<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Comm.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Form_Abstract
 */
require_once 'Giscuit/Form/Abstract.php';

/**
 * Form class for commenting in articles 
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Comm extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        //Set method and id
        $this->setMethod('post');
        $this->addAttribs(array(
            'id' => 'gtCommForm'
        ));
        
        //Text
        $this->addElement('textarea', 'text', array(
            'filters' => array(
                'StringTrim'
            ) , 
            'cols' => 50 , 
            'rows' => 10 , 
            'required' => true , 
            'label' => 'text' , 
            'id' => 'commText'
        ));
        
        //Submit
        $this->addElement('button', 'submit_button', array(
            'attribs' => array(
                'id' => 'gtCommSubmit'
            ) , 
            'required' => false , 
            'ignore' => true , 
            'label' => 'submit'
        ));
    
    }
}