<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Radio.php 1133 2011-03-14 16:12:16Z ue $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Element
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Form_Element_Radio
 */

/**
 * Radio element
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Element
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Element_Radio extends Zend_Form_Element_Radio
{
    /**
     * Set object state from options array
     *
     * @param  array $options
     * @return Zend_Form_Element
     */
    public function setOptions (array $options)
    {
        if (isset($options['database'])) {
            $db = Zend_Registry::get('db');
            $config = Zend_Registry::get('config');
            
            //Options
            $tableName = $options['database']['table'];
            
            //Schema
            if (isset($options['database']['schema'])) {
                $schemaName = $options['database']['schema'];
            } else {
                $schemaName = $config->database->schema . '_layers';
            }
            
            //Id
            if (isset($options['database']['id'])) {
                $idName = $options['database']['id'];
            } else {
                $idName = 'id';
            }
            
            //Name
            if (isset($options['database']['name'])) {
                $valueName = $options['database']['name'];
            } else {
                $valueName = 'name';
            }
            
            $select = $db->select();
            $select->from($schemaName . '.' . $tableName, array(
                $idName , 
                $valueName
            ));
            
            $rows = $db->fetchAll($select, NULL, Zend_Db::FETCH_ASSOC);
            
            $result = array();
            foreach ($rows as $row) {
                $result[$row[$idName]] = $row[$valueName];
            }
            
            $this->setMultiOptions($result);
        }
        
        parent::setOptions($options);
    }

}