<?php

/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Abstract.php 2828 2012-07-02 18:45:09Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Map
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * Class for abstract mapserver object
 *
 * @category   Giscuit
 * @package    Giscuit_Map
 * @copyright  Copyright (c) 2012 VEC
 */
abstract class Giscuit_Map_Abstract
{
    
    /**
     * Mapserver object
     *
     * @var mixed
     */
    protected $_obj;
    
    /**
     * Parent mapserver object
     *
     * @var mixed
     */
    public $parent = NULL;
    
    /**
     * Mapserver children object
     *
     * @var mixed
     */
    public $children = array();

    /**
     * Constructor
     *
     * @return void
     */
    //FIXME: 
    //abstract function __construct ();

    /**
     * Get mapserver object
     * 
     * @return void
     */
    public function getMsObj ()
    {
        return $this->_obj;
    }

    /**
     * Forward all methods to mapserver object
     * 
     * @return mixed
     */
    public function __call ($name, $arguments)
    {      
        //
        if($name == 'set' && $arguments[0] == 'name' && $this->name) {
            throw new Giscuit_Exception("Can't change name property to ({$this->name})");
        }
        
        return call_user_func_array(array(
            $this->_obj , 
            $name
        ), $arguments);
    }

    /**
     * Forward all propreties to mapserver object
     * 
     * @return mixed
     */
    public function __get ($name)
    {
          return $this->_obj->$name;
    }
    
    /**
     * Forward all propreties to mapserver object
     * 
     * @return mixed
     */
    public function __set ($name, $value)
    {
        return call_user_func_array(array(
            $this->_obj , 
            'set'
        ), array($name, $value));
    }
       
}