<?php

/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Phone.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * Phone validator
 * 
 * @category   Giscuit
 * @package    Giscuit_Validate
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Validate_Phone extends Zend_Validate_Abstract
{

    const NOT_VALID = 'phoneInvalid';

    /**
     * Validation failure message template definitions
     *
     * @var array
     */
    protected $_messageTemplates = array(
        self::NOT_VALID => "Phone number '%value%' has invalid format"
    );

    /**
     * Defined by Zend_Validate_Interface
     *
     * Returns true if and only if $value is has a valid phone format
     *
     * @param  string $value
     * @return boolean
     */
    public function isValid ($value)
    {
        $this->_setValue($value);

        if (! preg_match('/\(?([0-9]{2})\)?([ .-]?)([0-9]{2})\2([0-9]{2})$/', $value)) {
            $this->_error(self::NOT_VALID);
            return false;
        }

        return true;
    }

}
