<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: FormGtautocomplete.php 3228 2012-12-24 16:06:01Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_View_Helper
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_View_Helper_FormElement
 */
require_once 'Zend/View/Helper/FormElement.php';

/**
 * Generate an autocomplete element
 * 
 * @category   Giscuit
 * @package    Giscuit_View_Helper
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_View_Helper_FormGtautocomplete extends Zend_View_Helper_FormElement
{
    /**
     * Generates a 'autocomplete' element.
     *
     * @access public
     *
     * @param string|array $name If a string, the element name.  If an
     * array, all other parameters are ignored, and the array elements
     * are used in place of added parameters.
     *
     * @param mixed $value The element value.
     *
     * @param array $attribs Attributes for the element tag.
     *
     * @return string The element XHTML.
     */
    public function formGtautocomplete($name, $value = null, $attribs = null)
    {
        $info = $this->_getInfo($name, $value, $attribs);
        extract($info); // name, value, attribs, options, listsep, disable

        // build the element
        $disabled = '';
        if ($disable) {
            // disabled
            $disabled = ' disabled="disabled"';
        }
        
        // XHTML or HTML end tag?
        $endTag = ' />';
        if (($this->view instanceof Zend_View_Abstract) && !$this->view->doctype()->isXhtml()) {
            $endTag= '>';
        }

        $xhtml = '<div class="gtautocomplete"' . ' id="' . $this->view->escape($id) . '"' . '><input type="text"'
                . ' name="' . $this->view->escape($name) . '"'
                . ' id="' . $this->view->escape($id) . 'Input"'
                . ' value="' . $this->view->escape($value) . '"'
                . $disabled
                . $this->_htmlAttribs($attribs)
                . $endTag . "<div id='" . $this->view->escape($id) . "Container'></div></div>";

        return $xhtml;
    }
}
