<?php

//Patch information
$currentVersion = '1.3.2';
$updateVersion = '1.4.0';
$downloadsUrl = 'http://downloads.giscuit.com';

//Defines
require_once '..' . DIRECTORY_SEPARATOR . 'Defines.php';
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
    define('GT_MS_PATH', realpath(GT_APP_PATH . DIR_SEP . '..' . DIR_SEP . '..' . DIR_SEP . '..'));    
    } else {
    define('GT_MS_PATH', NULL);
}

//Errors
error_reporting(E_ALL | E_STRICT);
ini_set('display_startup_errors', 1);
ini_set('display_errors', 1);
ini_set('log_errors', 0);

//Include_path
$paths = array(
    realpath(GT_LIBRARY_PATH) , 
    get_include_path()
);
set_include_path(implode(PATH_SEPARATOR, $paths));

//Loader
require_once 'Zend/Loader/Autoloader.php';
$loader = Zend_Loader_Autoloader::getInstance();
$loader->registerNamespace('Giscuit_');

//Translate
$translate = new Zend_Translate('tmx', GT_LANGUAGES_PATH . DIR_SEP . 'admin.en.tmx', 'en');
Zend_Registry::set('Zend_Translate', $translate);

//Config
$config = new Zend_Config_Xml(GT_CONFIG_PATH . DIR_SEP . 'config.xml', null, array(
    'skipExtends' => true , 
    'allowModifications' => true
));

//
$view = new Zend_View();
$view->type = 'patch';
$view->httpPath = $config->production->httpPath;
$view->licenseType = $config->production->licenses->type;


//
$view->params = '';

//Install 
if (isset($_GET['install']) && $_GET['install'] == 't') {
	$view->install = 't';
	
	if ($config->production->version == $updateVersion) {
    	$view->bd = "System was already updated to this version";
    	
	} else if ($config->production->version != $currentVersion) {
    	$view->bd = "This patch is for version {$currentVersion}";
	    
	} else {
	    //Initialize database
	    Giscuit_Controller_Plugin_Init::parseDbParams($config->production->database);
	    $db = Zend_Db::factory($config->production->database);
	    $db->getConnection();
	    Zend_Db_Table_Abstract::setDefaultAdapter($db);
	    
	    $db->beginTransaction();
	    try {
	    	//Patch process BEGIN
	    	
	        //Update languages
	        updateLanguages(array(
	            'en' => array(
                    'oneLayerMustBeVisible' => 'At least one vector layer must be visible',
                    'querybuilderHelp' => 'Click on the table cell (field, function, operator or value) to change it\'s value. &lt;br&gt; You can find more information about this tool &lt;a href=&quot;http://docs.giscuit.com/En/tutorial_refguide.user.desktop.querybuilder.pkg.html&quot; target=&quot;_blank&quot;&gt;here&lt;/a&gt;',
                    'fewSeconds' => 'Few seconds' ,
                    '1minute' => '1 minute' ,
                    'minutes' => 'minutes' ,
                    '1hour' => '1 hour' ,
                    'hours' => 'hours' ,
                    '1day' => '1 day' ,
                    'days' => 'days' ,
                    'weeks' => 'weeks' ,
                    'months' => 'months' ,
                    'oneLayerMustBeVisible' => 'At least one vector layer must be visible' ,
                    'path' => 'Path' ,
                    'weekdaysString' => 'Su,Mo,Tu,We,Th,Fr,Sa' ,
                    'monthsString' => 'January,February,March,April,May,June,July,August,September,October,November,December' ,
                    'month' => 'Month' ,
                    'year' => 'Year' 
	            ),
	            'ro' => array(
                    'geolocationDataNotShared' => 'Utilizator nu a partajat poziţia lui curentă',
                    'markAndShare' => 'Marchează şi partajează',
                    'oneLayerMustBeVisible' => 'Cel puțin un strat vector trebuie să fie vizibil',
                    'querybuilderHelp' => 'Apăsaţi pe celulă din tabel (câmp, funcţia, operatorul sau valoare) pentru a schimba valoarea.&lt;br&gt; Puteţi găsi mai multă informaţie despre acest instrument <a href="http://docs.giscuit.com/En/tutorial_refguide.user.desktop.querybuilder.pkg.html" target="_blank">aici</a>',
                    'fewSeconds' => 'Cîteva secunde' ,
                    '1minute' => 'O minută' ,
                    'minutes' => 'minute' ,
                    '1hour' => 'O oră' ,
                    'hours' => 'ore' ,
                    '1day' => 'O zi' ,
                    'days' => 'zile' ,
                    'weeks' => 'săptămîni' ,
                    'months' => 'luni' ,
                    'oneLayerMustBeVisible' => 'Cel puțin un strat vector trebuie să fie vizibil' ,
                    'path' => 'Cale' ,
                    'weekdaysString' => 'D,L,Ma,Mi,J,V,S' ,
                    'monthsString' => 'Ianuarie,Februarie,Martie,Aprilie,Mai,Iunie,Iulie,August,Septembrie,Octombrie,Noiembrie,Decembrie' ,
                    'month' => 'Luna' ,
                    'year' => 'Anul' 
	            ),
	            'ru' => array(
                    'help' => 'Помощь',
                    'oneLayerMustBeVisible' => 'Как минимум один векторный слой должен быть виден',
                    'querybuilderHelp' => 'Нажмите на ячейку таблицы (поле, функция, оператор или значение) чтобы изменить ее значение.&lt;br&gt; Вы можете найти более подробную информацию об этом инструменте <a href="http://docs.giscuit.com/En/tutorial_refguide.user.desktop.querybuilder.pkg.html" target="_blank">здесь</a>',
                    'fewSeconds' => 'Пару секунд' ,
                    '1minute' => '1 минута' ,
                    'minutes' => 'минут' ,
                    '1hour' => '1 час' ,
                    'hours' => 'часов' ,
                    '1day' => '1 день' ,
                    'days' => 'дней' ,
                    'weeks' => 'недель' ,
                    'months' => 'месяцев' ,
                    'oneLayerMustBeVisible' => 'Хотя бы один векторный слой должен быть виден' ,
                    'path' => 'Путь' ,
                    'weekdaysString' => 'Вс,Пн,Вт,Ср,Чт,Пт,Сб' ,
                    'monthsString' => 'Январь,Февраль Март,Апрель,Май,Июнь,Июль,Август,Сентябрь,Октябрь,Ноябрь,Декабрь' ,
                    'month' => 'Месяц' ,
                    'year' => 'Год' 
	            )
	        ));
	        
	        //Update tables
	        $defaultSchema = $config->production->database->schema;
	        
	        $patchSql = array(
	            "ALTER TABLE {$defaultSchema}.layers ADD COLUMN path_active character varying(50)",
	            
	            "CREATE FUNCTION {$defaultSchema}.layers_tree_active() RETURNS trigger
                    AS $$
                DECLARE 
                    parent_path TEXT DEFAULT '';
                    table_name text := TG_TABLE_SCHEMA || '.' || TG_TABLE_NAME;
                BEGIN
                
                    IF NEW.parent_id IS NOT NULL THEN
                        EXECUTE 'SELECT path_active FROM ' || table_name || ' WHERE id = ' || NEW.parent_id INTO parent_path;
                        NEW.path_active := parent_path||NEW.active||'/';
                    END IF;
                    
                    IF NEW.parent_id IS NULL THEN
                        NEW.path_active := '/'||NEW.active||'/';
                    END IF;
                
                    return NEW;
                END;
                $$
                    LANGUAGE plpgsql;",
                    
                "CREATE TRIGGER layers_tree_active_trigger
                    BEFORE INSERT OR UPDATE ON {$defaultSchema}.layers
                    FOR EACH ROW
                    EXECUTE PROCEDURE {$defaultSchema}.layers_tree_active();",
                    
                "UPDATE {$defaultSchema}.layers SET active = active",
                "ALTER TABLE {$defaultSchema}.classes ADD COLUMN label_text pg_catalog.text",
                
                "CREATE TABLE {$defaultSchema}.layer_cluster
                (
                    id integer NOT NULL,
                    cluster_active character(1) DEFAULT 'f'::bpchar,
                    cluster_maxdistance integer,
                    cluster_buffer integer,
                    cluster_region pg_catalog.text,
                    cluster_group pg_catalog.text,
                    cluster_filter pg_catalog.text
                )",
                "ALTER TABLE ONLY {$defaultSchema}.layer_cluster ADD CONSTRAINT layer_cluster_pkey PRIMARY KEY (id)",
                "ALTER TABLE ONLY {$defaultSchema}.layer_cluster ADD CONSTRAINT layer_cluster_id_fkey FOREIGN KEY (id) REFERENCES {$defaultSchema}.layers(id) ON DELETE CASCADE"
	        );
	        
	        foreach ($patchSql as $value) {
	            $db->query($value);
	        }
	        $db->commit();
	        
	        //Update config
	    	
	        //Patch process END
	        $config->production->version = $updateVersion;
	        
	        //
	        require_once GT_MODULES_PATH . DIR_SEP . 'admin' . DIR_SEP . 'controllers' . DIR_SEP . 'GenconfController.php';
	        Admin_GenconfController::escapeConfig($config->production);
	        
	        //
	        $writer = new Zend_Config_Writer_Xml(array(
	            'config' => $config , 
	            'filename' => GT_CONFIG_PATH . DIR_SEP . 'config.xml'
	        ));
	        $writer->write();
	        
	        //License
	        if(isset($_POST['agreement_text']) && $_POST['agreement_text']) {
	            file_put_contents(GT_APP_PATH . DIR_SEP . "LICENSE.txt", $_POST['agreement_text']);
	        }
	        
	        //Clear cache
	        $frontendOptions = array(
	            'lifetime' => 3600 , 
	            'automatic_serialization' => true
	        );
	        if(extension_loaded('apc')) {
	            $backendOptions = array(
	            );
	            $backend = 'Apc';            
	        } else {
	            $backendOptions = array(
	                'cache_dir' => GT_TMP_PATH
	            );
	            $backend = 'File';
	        }
	        $cache = Zend_Cache::factory('Core', $backend, $frontendOptions, $backendOptions);
	        $cache->clean(Zend_Cache::CLEANING_MODE_ALL);
	        
	        //Update cache
	        file_put_contents(GT_TMP_PATH . DIR_SEP . 'offline_timestamp', time());
	    
	        $view->bd = "Giscuit was successfully patched to version " . $updateVersion;
	    
	    } catch (Exception $e) {
	        $db->rollBack();
	        $view->bd = $e->getMessage();
		}
	}
} else {
	$view->install = 'f';
	
    $contentView = new Zend_View();
    $contentView->type = 'patch';
    $contentView->addScriptPath(GT_MODULES_PATH . DIR_SEP . 'default' . DIR_SEP . 
        'views' . DIR_SEP . 'scripts' . DIR_SEP . 'generic');
    
    $view->bd = $contentView->render('installLicenseAgreement' . GT_SCRIPT_EXT);
    
}

$view->addScriptPath(GT_LAYOUTS_PATH);
echo $view->render('install' . GT_SCRIPT_EXT);

function updateLanguages(array $messages = array()) {
    foreach ($messages as $languageKey => $languageValue) {
        
        $languageFile = GT_LANGUAGES_PATH . DIR_SEP . 'default.' . $languageKey . '.tmx';
        if(! file_exists($languageFile)) {
            continue;       
        }
        
        $translate = new Zend_Translate('tmx', $languageFile, $languageKey);
    
        $newMessages = array_merge($translate->getMessages(), $languageValue);
        $newTmx = Giscuit_Controller_Plugin_Abstract::arrayToTmx($languageKey, $newMessages);
        
        file_put_contents(GT_LANGUAGES_PATH . DIR_SEP . 'default.' . $languageKey . '.tmx', $newTmx);
    }    
}