/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Fullextent.js 2536 2012-04-12 21:23:20Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.fullextent = new Giscuit.Control.Fullextent();
    }
});

/**
 * Class: Giscuit.Control.Fullextent
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Control.Fullextent = OpenLayers.Class(Giscuit.Control, {
    
    active: false,
    
    button: null,
    
    initialize: function (options) {
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        
        var self = this;
        
        this.button = new YAHOO.widget.Button({ 
            label: gt.map.getControlIcon(7), 
            id: "gtControlFullextent", 
            onclick: {fn: function() {
                if(self.active) {
                    self.deactivate();
                } else {
                    self.activate();
                }
            }},
            title: gt.translate._('fullextent'), 
            container: "gtMapControls"
        });
        
        gt.map.addControl(this);
    },
    
    activate: function () {
        var activated = Giscuit.Control.prototype.activate.call(this);
        
        gt.map.zoomToExtent(gt.map.maxExtent);

        return activated;
    },

    deactivate: function () {
        var deactivated = Giscuit.Control.prototype.deactivate.call(this);
                
        return deactivated;
    },

    
    
    CLASS_NAME: "Giscuit.Control.Fullextent"
});