/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 *
 *
 * @version    $Id: Search.js 2536 2012-04-12 21:23:20Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 *
 */
Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.incidents = new Giscuit.Control.Incidents();
    }
});

/**
 * Class: Giscuit.Control.Incidents
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Control.Incidents = OpenLayers.Class(Giscuit.Control, {

    panel: null,
    
    button: null,
    
    dt: null,
    
    dtHeightCoef: 150,
    
    incidentsFormSubmit: null,
    
    incidentsFormBack: null,
    
    incidentsAddButton: null,
    
    notificationsButton: null,
    
    incidentsMenuButton: null,
    
    incidentsCloseButton: null,
    
    incidentsDeleteButton: null,
    
    incidentsCategoryMenuButton: null,
    
    lastAdded: null,
    
    lastSelected: null,
    
    drawControl: null,
    
    features: [],
    
    tooltip: null,
    
    tooltipShown: false,
    
    notificationsTooltipShown: false,
    
    dtTextLength: 22,
    
    dtRowsPerPage: 7,
    
    currentActiveValue: 1,
    
    currentCategoryValue: 0,
    
    
    notificationsAddButton: null,
    
    incidentsButton: null,
    
    notificationsDt: null,
    
    categoryArr: null,
    
    notificationsRowsPerPage: 7,
    
    notificationsControl: null,
    
    currentNotificationsId: null,
    
    notificationsZoneFeature: null,
    
    zoomLevel: null,
    
    initialize: function (options) {
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        this.zoomLevel = gt.config.resolutions.length - 3;
        
        var self = this;
        
        this.button = new YAHOO.widget.Button({ 
            label: gt.map.getControlIcon(29), 
            id: "gtControlSearch", 
            onclick: {
                fn: function() {
                    if(self.active) {
                        self.deactivate();
                    } else {
                        self.activate();
                    }
                }
            },
            title: gt.translate._('reports'), 
            container: "gtMapControls",
            type: 'checkbox'
        });
    },
    
    activate: function () {
        //Deactivate all active controls
        gt.map.deactivateAll();

        var activated = Giscuit.Control.prototype.activate.call(this);
        if (activated == true) {
            //Check button
            this.button.set('checked', true);
            
            if (gt.layer.Incidents.visibility == false) {
                var layerId = gt.control.layers.getLayerIdByClassName('Incidents');
                gt.control.layers.setSettings('view', layerId, true);
            }
            
            if (this.panel == null) {
                this.create();
                
                gt.accord.unsubscribe('afterPanelClose', this.closeMenuButtons);
                gt.accord.subscribe('afterPanelClose', this.closeMenuButtons, null, this);
            } else {
                gt.accord.openPanel(this.getPanelIndex());
            }
        } else {
            gt.accord.openPanel(this.getPanelIndex());
        }

        return activated;
    },

    deactivate: function () {

        var deactivated = Giscuit.Control.prototype.deactivate.call(this);
        if (deactivated == true) {
            if(this.lastSelected) {
                this.lastSelected.layer.drawFeature(this.lastSelected, 'default');
            }
            
            if(this.lastAdded != null) {
                gt.layer.Incidents.destroyFeatures([this.lastAdded]);
                this.lastAdded = null;
            }
            
            if (this.drawControl != null && this.drawControl.active) {
                this.drawControl.deactivate();
            }
            
            if (this.notificationsControl != null && this.notificationsControl.active) {
                this.notificationsControl.deactivate();
            }
            
            this.destroyNotificationsZone();
            
            //Uncheck button
            this.button.set('checked', false);
            
        }
        
        return deactivated;
    },
    
    create: function() {
        //Incidents html
        var html = '<div id="gtIncidentsMainPanel"><div id="gtIncidentsButtons">';
        html += '<input type="button" id="gtIncidentsAddButtonSubmit" name="menuButton" value="' + gt.translate._('addReport') + '">';
        html += '<select id="gtIncidentsAddButtonSelect" name="gtIncidentsAddButtonSelect">';
        html += '<option value="point">' + gt.translate._('point') + '</option>';
        html += '<option value="line">' + gt.translate._('line') + '</option>';
        html += '<option value="polygon">' + gt.translate._('polygon') + '</option>';
        html += '</select>';
        
        //html += '<div id="gtIncidentsButtons"><button type="button" id="gtIncidentsAddButton">' + gt.translate._('addReport') + '</button>';
        html += '<button type="button" id="gtIncidentsNotificationsButton">' + gt.translate._('alerts') + '</button>';

        html += '<input type="button" id="gtIncidentsMenuButtonSubmit" name="menuButton" value="' + gt.translate._('open') + '">';
        html += '<select id="gtIncidentsMenuButtonSelect" name="gtIncidentsMenuButtonSelect">';
        html += '<option value="0">' + gt.translate._('all') + '</option>';
        html += '<option value="1">' + gt.translate._('open') + '</option>';
        html += '<option value="2">' + gt.translate._('closed') + '</option>';
        html += '</select>';
        
        html += '<input type="button" id="gtIncidentsCategoryMenuSubmit" name="categoryMenuButton" style="display: none;">';
        html += '<select id="gtIncidentsCategoryMenuSelect" name="gtIncidentsCategoryMenuSelect" style="display: none;">';
        html += '<option value="0">' + gt.translate._('allCategories') + '</option>';
        html += '</select></div>';
        
        html += '<div id="gtIncidentsDatatable"></div>';
        html += '<div id="gtIncidentsManageButtonsDiv" style="display: none;"></div></div>';
            
        html += '<div id="gtIncidentsAddFormPH" style="display: none;"></div>';
            
        //Notifications html
        html += '<div id="gtNotificationsMainPanel" style="display: none;">';
        html += '<div id="gtNotificationsButtons"><button type="button" id="gtNotificationsAddButton">' + gt.translate._('addAlert') + '</button>';
        html += '<button type="button" id="gtNotificationsIncidentsButton">' + gt.translate._('reports') + '</button></div>';
        
        html += '<pre id="gtIncidentsErrorsDiv" style="color: #CC1100;"></pre>';
        html += '<div id="gtNotificationsDatatable">' + this.getLoadingImage() + '</div></div>';
        
        gt.accord.addPanel({
            label: gt.translate._('reports'),
            content: html
        });
        this.panel = gt.accord.getPanel(gt.accord.getPanels().length - 1);
        this.addHelpButton('http://docs.giscuit.com/En/tutorial_refguide.user.desktop.reports.pkg.html');
        /*
        this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Point, {
            callbacks: {
                "done": OpenLayers.Function.bind(this.addIncident, this)
            }
        });
        gt.map.addControl(this.drawControl);
        */
        this.incidentsAddButton = new YAHOO.widget.Button("gtIncidentsAddButtonSubmit", {  
            type: "menu",  
            menu: "gtIncidentsAddButtonSelect"
        }); 
        this.incidentsAddButton.getMenu().subscribe("click", function (p_sType, p_aArgs) {
            if (p_aArgs[1]) {
                if(! this.active) {
                    this.activate();
                }
                
                //Tooltip
                if (! this.tooltipShown && gt.config.tooltip == 't') {
                    gt.tooltip.cfg.setProperty('text', gt.translate._('drawPointHelp'));
                    gt.tooltip.showTooltip();
                    this.tooltipShown = true;
                }

                if (this.drawControl != null) {
                    this.drawControl.destroy();
                    this.drawControl = null;
                }
                
                if (p_aArgs[1].value == 'point') {
                    this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Point, {
                        callbacks: {
                            "done": OpenLayers.Function.bind(this.addIncident, this)
                        }
                    });
                } else if (p_aArgs[1].value == 'line') {
                    this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Path, {
                        callbacks: {
                            "done": OpenLayers.Function.bind(this.addIncident, this)
                        }
                    });
                } else if (p_aArgs[1].value == 'polygon') {
                    this.drawControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Polygon, {
                        callbacks: {
                            "done": OpenLayers.Function.bind(this.addIncident, this)
                        }
                    });
                }

                gt.map.addControl(this.drawControl);
                this.drawControl.activate();
            }
        }, null, this);

        this.notificationsButton = new YAHOO.widget.Button('gtIncidentsNotificationsButton');
        this.notificationsButton.on("click", function (evt) {
            if (this.drawControl && this.drawControl.active) {
                this.drawControl.deactivate();
            }
            
            if (this.notificationsDt == null) {
                YAHOO.util.Connect.asyncRequest('POST', gt.config.httpToolPath + '/incidents/getnotifications', {
                    success: function (o) {
                        try {
                            var responseText = YAHOO.lang.JSON.parse(o.responseText);
                        } catch(e) {
                            Giscuit.Util.parseFailure(o, e);
                            return;
                        }
                        
                        if (responseText.replyCode != 200) {
                            Giscuit.Util.invalidReplyCode(responseText);
                            return;
                        }

                        this.categoryArr = responseText.categories;
                        this.createNotificationsDt(responseText.records);
                    },
                    failure: Giscuit.Util.callbackFailure,
                    scope: this
                });
            }
            
            YAHOO.util.Dom.get('gtIncidentsMainPanel').style.display = 'none';
            YAHOO.util.Dom.get('gtNotificationsMainPanel').style.display = 'block';
        }, null, this);
        if (gt.config.guest == 't') {
            this.notificationsButton.setStyle('display', 'none');
        }
        
        this.incidentsMenuButton = new YAHOO.widget.Button("gtIncidentsMenuButtonSubmit", {  
            type: "menu",  
            menu: "gtIncidentsMenuButtonSelect"
        }); 
        this.incidentsMenuButton.getMenu().subscribe("click", function (p_sType, p_aArgs) {
            if (p_aArgs[1]) {
                this.incidentsMenuButton.set("label", p_aArgs[1].cfg.getProperty("text"));
                
                if (p_aArgs[1].value == 0) {
                    this.dt.showColumn('active');
                } else {
                    this.dt.hideColumn('active');
                }

                this.currentActiveValue = p_aArgs[1].value;
                
                gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
            }
        }, null, this);
        
        YAHOO.util.Connect.asyncRequest('GET', gt.config.httpToolPath + '/incidents/getcategories', {
            success: function (o) {
                try {
                    var responseText = YAHOO.lang.JSON.parse(o.responseText);
                } catch(e) {
                    Giscuit.Util.parseFailure(o, e);
                    return;
                }
                
                if (responseText.replyCode != 200) {
                    Giscuit.Util.invalidReplyCode(responseText);
                    return;
                }
                this.createCategoryMenuButton(responseText);
            },
            failure: function (o) {
                Giscuit.Util.callbackFailure(o);
            },
            scope: this
        });

        this.incidentsCloseButton = new YAHOO.widget.Button({
            id: "gtIncidentsCloseButton", 
            type: "button", 
            label: gt.translate._('close'), 
            container: "gtIncidentsManageButtonsDiv",
            disabled: true
        });
        
        this.incidentsCloseButton.on('click', function (evt) {
            var row = this.dt.getSelectedRows();
            var gid = this.dt.getRecord(row[0]).getData('gid');
            this.incidentsCloseButton.set('disabled', true);
            this.incidentsDeleteButton.set('disabled', true);
            
            YAHOO.util.Connect.asyncRequest('GET', gt.config.httpToolPath + '/incidents/setstatus/gid/' + gid, {
                success: function (o) {
                    try {
                        var responseText = YAHOO.lang.JSON.parse(o.responseText);
                    } catch(e) {
                        Giscuit.Util.parseFailure(o, e);
                        return;
                    }

                    if (responseText.replyCode != 200) {
                        Giscuit.Util.invalidReplyCode(responseText);
                        return;
                    }

                    gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
                },
                failure: function (o) {
                    Giscuit.Util.callbackFailure(o);
                },
                scope: this
            });
        }, null, this);
        
        this.incidentsDeleteButton = new YAHOO.widget.Button({
            id: "gtIncidentsDeleteButton", 
            type: "button", 
            label: gt.translate._('delete'), 
            container: "gtIncidentsManageButtonsDiv",
            disabled: true
        });
        
        this.incidentsDeleteButton.on('click', function (evt) {
            if (confirm(gt.translate._('deleteConfirm'))) {
                var row = this.dt.getSelectedRows();
                var gid = this.dt.getRecord(row[0]).getData('gid');
                this.incidentsDeleteButton.set('disabled', true);
                this.incidentsCloseButton.set('disabled', true);

                YAHOO.util.Connect.asyncRequest('GET', gt.config.httpToolPath + '/incidents/delete/gid/' + gid, {
                    success: function (o) {
                        try {
                            var responseText = YAHOO.lang.JSON.parse(o.responseText);
                        } catch(e) {
                            Giscuit.Util.parseFailure(o, e);
                            return;
                        }
                        
                        if (responseText.replyCode != 200) {
                            Giscuit.Util.invalidReplyCode(responseText);
                            return;
                        }
                        
                        gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
                    },
                    failure: function (o) {
                        Giscuit.Util.callbackFailure(o);
                    },
                    scope: this
                });
            }
        }, null, this);

        this.getFeaturesFromLayer();
        
        this.createIncidentsDt();
        
        //Notifications section
        if (gt.config.guest == 't') {
            gt.accord.openPanel(this.getPanelIndex());
            return;
        }
        
        this.notificationsAddButton = new YAHOO.widget.Button('gtNotificationsAddButton');
        this.notificationsAddButton.on("click", function (evt) {
            if(! this.active) {
                this.activate();
            }
            
            this.destroyNotificationsZone();
            
            YAHOO.util.Connect.asyncRequest('POST', this.notificationsDt.options.addDataUrl, {
                success: function (o) {
                    try {
                        var responseText = YAHOO.lang.JSON.parse(o.responseText);
                    } catch(e) {
                        Giscuit.Util.parseFailure(o, e);
                        return;
                    }
                    
                    if (responseText.replyCode != 200) {
                        Giscuit.Util.invalidReplyCode(responseText);
                        return;
                    }

                    this.notificationsDt.dt.addRow(responseText.record);
                    this.notificationsDt.dt.get('paginator').setPage(this.notificationsDt.dt.get('paginator').getTotalPages());
                },
                failure: function (o) {
                    Giscuit.Util.callbackFailure(o);
                },
                scope: this
            });
        }, null, this);
        
        this.incidentsButton = new YAHOO.widget.Button('gtNotificationsIncidentsButton');
        this.incidentsButton.on("click", function (evt) {
            if (this.notificationsControl.active) {
                this.notificationsControl.deactivate();
            }
            
            this.destroyNotificationsZone();
            YAHOO.util.Dom.get('gtNotificationsMainPanel').style.display = 'none';
            YAHOO.util.Dom.get('gtIncidentsMainPanel').style.display = 'block';
        }, null, this);
        
        this.notificationsControl = new OpenLayers.Control.DrawFeature(gt.layer.vector, OpenLayers.Handler.Polygon, {
            callbacks: {
                "done": OpenLayers.Function.bind(this.setNotificationsZone, this)
            }
        });
        gt.map.addControl(this.notificationsControl);
        
        gt.accord.openPanel(this.getPanelIndex());
        
    },
    
    createCategoryMenuButton: function (responseText) {
        var records = responseText.records;
        
        for (var i = 0; i < records.length; i++) {
            var option = document.createElement('option');
            option.value = records[i].id;
            option.text = records[i][responseText.currentKey];
            YAHOO.util.Dom.get('gtIncidentsCategoryMenuSelect').options.add(option);
        }
        this.incidentsCategoryMenuButton = new YAHOO.widget.Button("gtIncidentsCategoryMenuSubmit", {  
            type: "menu",  
            menu: "gtIncidentsCategoryMenuSelect",
            label: '<em style="width:75px;" id="gtIncidentsCategoryMenuText">' + gt.translate._('allCategories') + '</em>'
        }); 
        YAHOO.util.Dom.addClass(this.incidentsCategoryMenuButton.get('element'), 'gt-fixed-width-menu-btn'); 
        
        this.incidentsCategoryMenuButton.getMenu().subscribe("click", function (p_sType, p_aArgs) {
            if (p_aArgs[1]) {
                this.incidentsCategoryMenuButton.set("label", '<em style="width:75px;">' + p_aArgs[1].cfg.getProperty("text") + '</em>');
                
                this.currentCategoryValue = p_aArgs[1].value;
                
                gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
            }
        }, null, this);
        
    }, 
    
    createIncidentsDt: function () {
        var ds = new YAHOO.util.DataSource(this.features);
        ds.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
        ds.responseSchema = {
            fields: ["gid", "active", "title", "description", "date", "category_name", 
                "fname", "lname", "email", "image", "geometry"]
        };
        
        var paginator = new YAHOO.widget.Paginator({
            alwaysVisible: true,
            rowsPerPage: this.dtRowsPerPage,
            nextPageLinkLabel: gt.translate._('nextPage'),
            previousPageLinkLabel: gt.translate._('previousPage'),
            firstPageLinkLabel: gt.translate._('firstPage'),
            lastPageLinkLabel: gt.translate._('lastPage')
        });
        
        var formatDisplaySize = function (elCell, oRecord, oColumn, oData) {
            if (oData.length > gt.control.incidents.dtTextLength) {
                elCell.innerHTML = oData.substring(0, gt.control.incidents.dtTextLength - 1) + '...';
            } else {
                elCell.innerHTML = oData;
            }
        };
        
        var formatActiveField = function (elCell, oRecord, oColumn, oData) {
            var value = oRecord.getData(oColumn.key);
            
            if(value === true || value == 't') {
                elCell.innerHTML = gt.translate._('open');
            } else {
                elCell.innerHTML = gt.translate._('closed');
            }
        }
        
        var formatImageField = function (elCell, oRecord, oColumn, oData) {
            elCell.style.textAlign = 'center';
            elCell.innerHTML = oData;
        }
        
        var columnDefs = [ 
            {key: "title", resizeable: true, sortable: true, formatter: formatDisplaySize, label: gt.translate._('title')} ,
            {key: "description", resizeable: true, sortable: true, formatter: formatDisplaySize, label: gt.translate._('description')} ,
            {key: "category_name", resizeable: true, sortable: true, label: gt.translate._('category')} ,
            {key: "active", resizeable: true, sortable: true, formatter: formatActiveField, label: gt.translate._('status')} ,
            {key: "date", resizeable: true, sortable: true, label: gt.translate._('date')},
            {key: "fname", resizeable: true, sortable: true, hidden: true, label: gt.translate._('fname')} ,
            {key: "lname", resizeable: true, sortable: true, hidden: true, label: gt.translate._('lname')} ,
            {key: "email", resizeable: true, sortable: true, hidden: true, label: gt.translate._('email')} ,
            {key: "image", resizeable: true, sortable: true, width: 30, formatter: formatImageField, label: gt.translate._('image')} 
        ];

        this.dt = new YAHOO.widget.ScrollingDataTable("gtIncidentsDatatable", columnDefs, ds, {
            selectionMode: "single",
            width: '99.5%',
            //height: gt.config.accordPanelMaxHeight - 150 + "px",
            MSG_EMPTY: gt.translate._('emptyResult'),
            MSG_LOADING: gt.translate._('loading') + "...",
            paginator: paginator
        });
        
        gt.accord.on('afterPanelOpen', this.updateDtHeight, null, this);
        
        this.dt.subscribe("rowMouseoverEvent", this.dt.onEventHighlightRow);
        this.dt.subscribe("rowMouseoutEvent", this.dt.onEventUnhighlightRow);
        
        this.dt.subscribe("postRenderEvent", function () {
            this.setDtTooltips();
        }, null, this);
        
        //Select row
        this.dt.subscribe("cellClickEvent", function (oArgs) {
            var column = this.dt.getColumn(oArgs.target).key;
            
            if (column == 'image') {
                return;
            }
            
            this.dt.onEventSelectRow(oArgs);

            var row = this.dt.getSelectedRows();

            if (this.incidentsCloseButton != null) {
                this.incidentsCloseButton.set('disabled', false);
                
                if (this.dt.getRecord(row[0]).getData('active') == 't') {
                    this.incidentsCloseButton.set('label', gt.translate._('close'));
                } else {
                    this.incidentsCloseButton.set('label', gt.translate._('open'));
                }
            }
            
            if (this.incidentsDeleteButton != null) {
                this.incidentsDeleteButton.set('disabled', false);
            }

            var geometry = this.dt.getRecord(row[0]).getData('geometry');
            
            //
            if(this.lastSelected) {
                this.lastSelected.layer.drawFeature(this.lastSelected, 'default');
            }
            this.lastSelected = gt.layer.Incidents.getFeatureBy('geometry', geometry);
            this.lastSelected.layer.drawFeature(this.lastSelected, 'select');            

            gt.map.zoomToExtent(geometry.getBounds());
            if (geometry instanceof OpenLayers.Geometry.Point) {
                gt.map.zoomTo(this.zoomLevel);
            }
            
        }, null, this);
        
        if (gt.pluginParams.incidentsSetstatusIsAllowed) {
            this.dt.showColumn('fname');
            this.dt.showColumn('lname');
            this.dt.showColumn('email');
        }
    }, 
    
    createNotificationsDt: function (records) {

        var deleteFormatter = function(elCell, oRecord, oColumn, oData) {
            var image = document.createElement('img');
            image.style.cursor = 'pointer';
            image.src = gt.config.httpImagePath + '/list_remove.png';
            image.title = gt.translate._('delete');
            
            YAHOO.util.Event.addListener(image, "click", function(oArgs) {
                if (confirm(gt.translate._('deleteConfirm'))) {
                    YAHOO.util.Event.purgeElement(this);
                    
                    var htmlRow = this.parentNode.parentNode.parentNode;
                    var id = gt.control.incidents.notificationsDt.dt.getRecord(htmlRow).getData('id');

                    gt.control.incidents.notificationsDt.dt.deleteRow(htmlRow);
                    YAHOO.util.Dom.get('gtIncidentsErrorsDiv').innerHTML = '';

                    YAHOO.util.Connect.asyncRequest('POST', gt.control.incidents.notificationsDt.options.deleteDataUrl + '/id/' + id, {
                        success: function (o) {
                            gt.control.incidents.notificationsDt.options.afterRowDelete.fire();
                        },
                        failure: Giscuit.Util.callbackFailure,
                        scope: this
                    });
                }
            });
            
            elCell.style.textAlign = 'center';
            elCell.appendChild(image);
        };
        
        var geometryFormatter = function(elCell, oRecord, oColumn, oData) {
            if (oData == null) {
                gt.control.incidents.createAddZoneButton(elCell);
            } else {
                gt.control.incidents.createUpdateDeleteZoneButtons(elCell);
            }
        };
        
        var categoryFormatter = function(elCell, oRecord, oColumn, oData) {
            var field = oRecord.getData('category_id');
            var label = null;
            var categoryArr = gt.control.incidents.categoryArr;
            
            for(var i=0; i < categoryArr.length; i++) {
                if(field == categoryArr[i].value) {
                    label = categoryArr[i].label;
                    break;
                }
            }
            
            if(label) {
                elCell.innerHTML = label;
            } else {
                elCell.innerHTML = '';
            }
        };

        var notificationsOptions = {
            fields : [
                "id" , 
                "user_id" ,
                "category_id" ,
                "the_geom" ,
                "delete"
            ] ,
            columnDefs : [
                {
                    key: "category_id" ,
                    label: gt.translate._("category") ,
                    editor: new YAHOO.widget.DropdownCellEditor({
                        dropdownOptions: this.categoryArr ,
                        disableBtns: false
                    }) ,
                    formatter: categoryFormatter
                },
                {key: "the_geom", formatter: geometryFormatter, label: gt.translate._('geometry')} ,
                {key: "delete", formatter: deleteFormatter, label: gt.translate._('delete')} 
            ],
            dataUrl : records ,
            dataSourceType: YAHOO.util.DataSource.TYPE_JSARRAY ,
            addDataUrl : gt.config.httpToolPath + '/incidents/addnotification' ,
            updateDataUrl : gt.config.httpToolPath + '/incidents/updatenotification' ,
            deleteDataUrl : gt.config.httpToolPath + '/incidents/deletenotification' ,
            container : 'gtNotificationsDatatable' ,
            rowsPerPage : this.notificationsRowsPerPage ,
            keyColumn : 'id'
        };  

        this.notificationsDt = new Giscuit.Datatable(notificationsOptions);
        
        this.notificationsDt.cellClick = function (oArgs) {
            var column = this.dt.getColumn(oArgs.target).key;
            if (column == 'category_id') {
                this.dt.onEventShowCellEditor(oArgs);
            }
        }
        
        this.notificationsDt.editRow = function (oArgs) {

            if(oArgs.editor != undefined) {
                var id = oArgs.editor.getRecord().getData(this.options.keyColumn);
                var column = oArgs.editor.getColumn().key;
                var data = oArgs.newData;
            } else {
                var id = oArgs.id;
                var column = oArgs.column;
                var data = oArgs.data;
            }
            
            var params = 'data=' + data + '&id=' + id + '&column=' + column;
            var url = this.options.updateDataUrl;
            
            YAHOO.util.Dom.get('gtIncidentsErrorsDiv').innerHTML = '';

            YAHOO.util.Connect.asyncRequest('POST', url, {
                success: function (o) {
                    try {
                        var responseText = YAHOO.lang.JSON.parse(o.responseText);
                    } catch(e) {
                        Giscuit.Util.parseFailure(o, e);
                        return;
                    }
                    
                    if (responseText.replyCode != 200) {
                        Giscuit.Util.invalidReplyCode(responseText);
                        return;
                    }
                    
                    if (responseText.error) {
                        YAHOO.util.Dom.get('gtIncidentsErrorsDiv').innerHTML = '<br>' + responseText.error;
                    }
                },
                failure: Giscuit.Util.callbackFailure,
                scope: this
            }, params);
        };
        
        this.notificationsDt.initialize();
    } ,
    
    createAddZoneButton: function (elCell) {
        var image = document.createElement('img');
        image.style.cursor = 'pointer';
        image.src = gt.config.httpImagePath + '/list_add.png';
        image.title = gt.translate._('add');
        
        YAHOO.util.Event.addListener(image, "click", function(oArgs) {
            //Tooltip
            if (! this.notificationsTooltipShown && gt.config.tooltip == 't') {
                gt.tooltip.cfg.setProperty('text', gt.translate._('drawGeometryHelp'));
                gt.tooltip.showTooltip();
                this.notificationsTooltipShown = true;
            }
            
            var htmlRow = this.parentNode.parentNode.parentNode;
            var id = gt.control.incidents.notificationsDt.dt.getRecord(htmlRow).getData('id');
            gt.control.incidents.currentNotificationsId = id;
            
            gt.control.incidents.destroyNotificationsZone();
            
            gt.control.incidents.notificationsControl.activate();
        });

        elCell.style.textAlign = 'center';
        elCell.appendChild(image);
    },
    
    createUpdateDeleteZoneButtons: function (elCell) {
        var updateImage = document.createElement('div');
        updateImage.style.display = 'inline';

        updateImage.innerHTML = gt.map.getControlIcon(6, gt.translate._('edit'));
        updateImage.firstChild.style.display = 'inline';
        updateImage.firstChild.style.cursor = 'pointer';
        updateImage.firstChild.innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;';
        
        YAHOO.util.Event.addListener(updateImage, "click", function(oArgs) {
            if (confirm(gt.translate._('updateConfirm'))) {
                //Tooltip
                if (! this.notificationsTooltipShown && gt.config.tooltip == 't') {
                    gt.tooltip.cfg.setProperty('text', gt.translate._('drawGeometryHelp'));
                    gt.tooltip.showTooltip();
                    this.notificationsTooltipShown = true;
                }
                
                var htmlRow = this.parentNode.parentNode.parentNode;
                var id = gt.control.incidents.notificationsDt.dt.getRecord(htmlRow).getData('id');
                gt.control.incidents.currentNotificationsId = id;
                
                gt.control.incidents.destroyNotificationsZone();
    
                gt.control.incidents.notificationsControl.activate();
            }
        });
        
        var deleteImage = document.createElement('img');
        deleteImage.style.cursor = 'pointer';
        deleteImage.style.marginBottom = '-3px';
        deleteImage.src = gt.config.httpImagePath + '/list_remove.png';
        deleteImage.title = gt.translate._('delete');
        
        YAHOO.util.Event.addListener(deleteImage, "click", function(oArgs) {
            if (confirm(gt.translate._('deleteConfirm'))) {
                var htmlRow = this.parentNode.parentNode.parentNode;
                var id = gt.control.incidents.notificationsDt.dt.getRecord(htmlRow).getData('id');

                var updateData = {};
                updateData.id = id;
                updateData.column = 'the_geom';
                updateData.data = '';

                gt.control.incidents.notificationsDt.editRow(updateData);
                
                gt.control.incidents.destroyNotificationsZone();
                YAHOO.util.Event.purgeElement(this.parentNode, true);
                
                var parentNode = this.parentNode;
                this.parentNode.innerHTML = '';
                gt.control.incidents.createAddZoneButton(parentNode);
            }
        });
        
        var viewImage = document.createElement('div');
        viewImage.style.display = 'inline';

        viewImage.innerHTML = gt.map.getControlIcon(23, gt.translate._('view'));
        viewImage.firstChild.style.display = 'inline';
        viewImage.firstChild.style.cursor = 'pointer';
        viewImage.firstChild.innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;';
        
        YAHOO.util.Event.addListener(viewImage, "click", function(oArgs) {
            var htmlRow = this.parentNode.parentNode.parentNode;
            var geomText = gt.control.incidents.notificationsDt.dt.getRecord(htmlRow).getData('the_geom');
            
            var polygon = new OpenLayers.Geometry.fromWKT(geomText);
            
            gt.control.incidents.destroyNotificationsZone();
            
            gt.control.incidents.notificationsZoneFeature = new OpenLayers.Feature.Vector(polygon);

            gt.layer.Incidents.addFeatures([gt.control.incidents.notificationsZoneFeature]);
        });
        
        elCell.style.textAlign = 'center';
        elCell.appendChild(updateImage);
        elCell.appendChild(deleteImage);
        elCell.appendChild(viewImage);
    },
    
    getIncidentsFormSuccess: function (o) {
        try {
            var responseText = YAHOO.lang.JSON.parse(o.responseText);
        } catch(e) {
            Giscuit.Util.parseFailure(o, e);
            return;
        } 
        
        if (responseText.replyCode != 200) {
            Giscuit.Util.invalidReplyCode(responseText);
            return;
        }

        if (this.incidentsFormSubmit != null) {
            this.incidentsFormSubmit.destroy();
            this.incidentsFormSubmit = null;
        }
        
        if (this.incidentsFormBack != null) {
            this.incidentsFormBack.destroy();
            this.incidentsFormBack = null;
        }
        YAHOO.util.Dom.get('gtIncidentsAddFormPH').innerHTML = responseText.form;
        
        this.incidentsFormSubmit = new YAHOO.widget.Button('gtIncidentsSubmit');
        this.incidentsFormBack = new YAHOO.widget.Button('gtIncidentsBack');
        
        this.incidentsFormSubmit.on("click", function(evt) {
            this.incidentsFormSubmit.set('disabled', true);

            var submitCallback = {
                upload: this.incidentSubmitSuccess,
                timeout: this.callbackTimeout,
                failure: this.callbackFailure,
                scope: this
            };

            var postData = 'geometry=' + this.lastAdded.geometry.toString();

            YAHOO.util.Connect.setForm('gtIncidentsForm', true);
            YAHOO.util.Connect.asyncRequest('POST', gt.config.httpToolPath + '/incidents/add', submitCallback, postData);
            
        }, null, this);

        this.incidentsFormBack.on("click", function(evt) {
            gt.layer.Incidents.removeFeatures([this.lastAdded]);
            
            YAHOO.util.Dom.get('gtIncidentsMainPanel').style.display = 'block';
            YAHOO.util.Dom.get('gtIncidentsAddFormPH').style.display = 'none';
        }, null, this);
    },
    
    addIncident: function (geom) {
        //Check if valid Polygon
        if(geom instanceof OpenLayers.Geometry.Polygon && geom.getVertices().length < 3) {
            return;
        }
        
        //Check if valid Line
        if(geom instanceof OpenLayers.Geometry.LineString && geom.getVertices().length == 2
            && geom.components[0].distanceTo(geom.components[1]) == 0) {
            return;
        }

        this.lastAdded = new OpenLayers.Feature.Vector(geom);
        gt.layer.Incidents.addFeatures([this.lastAdded]);
        
        this.drawControl.deactivate();
        
        var url = gt.config.httpToolPath + '/incidents/add';
        
        var getIncidentsFormCallback = {
            success: this.getIncidentsFormSuccess,
            timeout: this.callbackTimeout,
            failure: this.callbackFailure,
            scope: this
        };

        YAHOO.util.Connect.asyncRequest('GET', url, getIncidentsFormCallback);

        YAHOO.util.Dom.get('gtIncidentsMainPanel').style.display = 'none';
        YAHOO.util.Dom.get('gtIncidentsAddFormPH').style.display = 'block';
        YAHOO.util.Dom.get('gtIncidentsAddFormPH').innerHTML = this.getLoadingImage();
    },
    
    incidentSubmitSuccess: function (o) {
        this.incidentsFormSubmit.set('disabled', false);
        
        try {
            var responseText = YAHOO.lang.JSON.parse(o.responseText);
        } catch(e) {
            Giscuit.Util.parseFailure(o, e);
            return;
        }
        
        if (responseText.replyCode != 200) {
            Giscuit.Util.invalidReplyCode(responseText);
            return;
        }
        
        if (typeof responseText.form == 'undefined') {
            YAHOO.util.Dom.get('gtIncidentsAddFormPH').style.display = 'none';
            YAHOO.util.Dom.get('gtIncidentsMainPanel').style.display = 'block';
            
            gt.layer.Incidents.load(null, this.currentActiveValue, this.currentCategoryValue);
        } else {
            this.getIncidentsFormSuccess(o);
        }
    },
    
    getFeaturesFromLayer: function() {
        this.features.length = 0;
        
        for (var i = 0; i < gt.layer.Incidents.features.length; i++) {
            var tempObj = YAHOO.lang.JSON.parse(YAHOO.lang.JSON.stringify(gt.layer.Incidents.features[i].attributes));
            tempObj.geometry = gt.layer.Incidents.features[i].geometry;

            this.features.push(tempObj);
        }
        
        if (gt.pluginParams.incidentsSetstatusIsAllowed) {
            YAHOO.util.Dom.get('gtIncidentsManageButtonsDiv').style.display = 'block';
        }
    },
    
    setDtTooltips: function() {
        var rows = this.dt.getTbodyEl().rows;
        var metadataEls = [];
        for (var i = 0; i < rows.length; i++) {
            metadataEls.push(rows[i].children[0]);
            metadataEls.push(rows[i].children[1]);
        }
        metadataEls.push('gtIncidentsTooltip');
        
        if(this.tooltip != null) {
            this.tooltip.destroy();
        }

        this.tooltip = new YAHOO.widget.Tooltip("gtIncidentsTooltip", { 
            context: metadataEls,
            hidedelay: 500 ,
            showdelay: 500 ,
            autodismissdelay: 1000 * 60
        });

        this.tooltip.bringToTop();
        this.tooltip.doShow = Giscuit.Util.tooltipDoShow;
        
        this.tooltip.contextTriggerEvent.subscribe(function(type, args, dt) {
            var el = dt.getTdEl(args[0]);
            var data = dt.getRecord(el).getData();
            var column = dt.getColumn(el).key;

            if (column == 'title') {
                this.cfg.setProperty("text", data.title.replace(/\n/g, '<br>'));
            } else if (column == 'description') {
                this.cfg.setProperty("text", data.description.replace(/\n/g, '<br>'));
            } 
        }, this.dt);
    },
    
    setNotificationsZone: function (geometry) {
        this.notificationsControl.deactivate();
        
        var updateData = {};
        updateData.id = this.currentNotificationsId;
        updateData.column = 'the_geom';
        updateData.data = geometry.toString();

        this.notificationsDt.editRow(updateData);
        
        var dtRecords = this.notificationsDt.dt.getRecordSet().getRecords();
        for (var i = 0; i < dtRecords.length; i++) {
            if (dtRecords[i].getData('id') == this.currentNotificationsId) {
                dtRecords[i].setData('the_geom', geometry.toString());
                var elColumn = this.notificationsDt.dt.getColumn('the_geom');
                var elCell = this.notificationsDt.dt.getTdEl({record: dtRecords[i], column: elColumn}).firstChild;
                break;
            }
        }
        
        YAHOO.util.Event.purgeElement(elCell, true);
        elCell.innerHTML = '';
        
        this.createUpdateDeleteZoneButtons(elCell);
    },
    
    destroyNotificationsZone: function () {
        if (this.notificationsZoneFeature != null) {
            gt.layer.vector.destroyFeatures([this.notificationsZoneFeature]);
            this.notificationsZoneFeature = null;
        }
    } ,
    
    closeMenuButtons: function () {
        //Hide menu's if open
        this.incidentsAddButton.getMenu().hide();
        this.incidentsCategoryMenuButton.getMenu().hide();
        this.incidentsMenuButton.getMenu().hide();
    },
    
    clear: function() {
        this.deactivate();
        
        gt.accord.unsubscribe('afterPanelOpen', this.updateDtHeight);
        
        var elements = [
            'dt' ,
            'tooltip' ,    
            'drawControl',
            'incidentsAddButton' ,
            'incidentsButton',
            'incidentsMenuButton' ,
            'incidentsCategoryMenuButton' ,
            'incidentsCloseButton' ,
            'incidentsDeleteButton',
            'incidentsFormSubmit',
            'incidentsFormBack',
            'notificationsButton' ,
            'notificationsControl',
            'notificationsDt',
            'notificationsAddButton'
         ];
         for(var i=0; i < elements.length; i++) {
             if(this[elements[i]] != null) {
                 this[elements[i]].destroy();
                 this[elements[i]] = null;
             }
         }
         
         Giscuit.Control.prototype.clear.call(this);
    },
    
    updateDtHeight: function(args) {
        if(this.panel == args.panel && this.dt) {
            this.setOptimalDatatableHeight(this.dt, this.dtHeightCoef);
        }
    },
    
    CLASS_NAME: "Giscuit.Control.Incidents"
});