/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Serial.js 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */

//Get devices
function _gtconngetdevices() {
    gt.control.serial.devices = [];
    for(var i=0; i < arguments.length; i++) {
        gt.control.serial.devices.push({'label': arguments[i], 'address': arguments[i]});
    }
    
    //
    gt.control.serial.events.triggerEvent('getdevices', gt.control.serial.devices);
}

//Open
function _gtconnopen() {
    gt.control.serial.status = 1;
    
    //
    gt.control.serial.events.triggerEvent('open', true);
}
function _gtconnopenfail(evt) {
    gt.control.serial.status = 0;
    
    //
    gt.control.serial.events.triggerEvent('open', evt);
    
    //
    debug.warn(evt);
}

//Close
function _gtconnclose() {
    gt.control.serial.status = 0;
    
    //
    gt.control.serial.events.triggerEvent('close', true);
}
function _gtconnclosefail(evt) {
    gt.control.serial.status = 1;
    
    //
    gt.control.serial.events.triggerEvent('close', evt);
    
    //
    debug.warn(evt);
}

//Read
function _gtconnread(evt) {
    //
    gt.control.serial.events.triggerEvent('read', evt);
}
function _gtconnreadfail(evt) {
    //
    gt.control.serial.events.triggerEvent('readfail', evt);
    
    //
    debug.warn(evt);
}

//Initialize
function _gtconnstart(evt) {
    gt.control.serial.render();
}

/**
 * Class: Giscuit.Util.Serialjava
 */
Giscuit.Util.Serialjava = {
    
    devices: [],
    
    status: 0,
    
    plugin: null,
    
    getDevices: function() {
        this.plugin.getDevices();
    },    
    
    open: function (device, baudrate) {
        this.status = 0;
        this.socket = null;
        
        //
        this.plugin.open(device, baudrate);
    },
    
    close: function () {
        this.status = 0;
        
        //
        this.plugin.close();
    },
    
    write: function() {
        //
        this.events.triggerEvent('write', result);
    },
    
    initializePlugin: function() {
        $.mobile.showPageLoadingMsg();
        
        //
        var archives = ['gtconn.jar', 'plugin.jar', 'jssc.jar'];
        for(var i=0; i < archives.length; i++) {
            archives[i] = gt.config.httpJar + '/' +  archives[i];
        }
        archives = archives.join(', ');
        
        //
        this.plugin = document.createElement('applet');
        this.plugin.archive = archives;
        this.plugin.code = 'gtconn.Serial';
        this.plugin.width = '250';
        this.plugin.height = '250';
        this.plugin.mayscript = 'mayscript';
        this.plugin.style.position = 'absolute';
        this.plugin.style.top = '-250px';
        document.getElementsByTagName('body')[0].appendChild(this.plugin);
    }

};