<?php

class InfoControllerTest extends Giscuit_Test_PHPUnit_ControllerTestCase
{
    protected $_layerName = 'Worldboundaries';
    
    protected $_infoParams = array (
        'x' => '427',
        'y' => '133',
        'width' => '950',
        'height' => '600',
        'lon' => '28.126074790955',
        'lat' => '47.896949768066',
        'bbox' => '25.780494,45.331642,30.999,48.627541'
    );
    
    protected function _getIdFromClass($layer)
    {
        $layersTable = new Giscuit_Db_Table_Layers();                
        $row = $layersTable->getItems(array('whereClass' => $layer));
        foreach($row as $r) {
            $id = $r['id'];
        }        
        return $id;
    }
    
    protected function _setSelectable()
    {
        $this->_testLoginActionSuccess();
        
        $id = $this->_getIdFromClass($this->_layerName);

        $this->dispatch('/' . $this->_language . '/tool/privatelayers/edit/id/' . $id . '/column/select/value/true');
        
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertEquals($response['replyCode'], 200);
        
        $this->clear();
    }
    
    protected function _unsetSelectable()
    {
        $this->_testLoginActionSuccess();
        
        $id = $this->_getIdFromClass($this->_layerName);
        
        $this->dispatch('/' . $this->_language . '/tool/privatelayers/edit/id/' . $id . '/column/select/value/false');
        
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertEquals($response['replyCode'], 200);
        
        $this->clear();
    }

    public function testIndexAction()
    {
        $this->_testLoginActionSuccess();
        $this->_setSelectable();
        
        $this->request->setMethod('POST')->setPost($this->_infoParams);
        $this->dispatch('/' . $this->_language . '/tool/info');
        
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertEquals($response['replyCode'], 200);
        
        foreach($response['records'] as $rec) {
            if ( $rec['html'] == 'World boundaries' ) {
                $this->assertEquals($rec['children'][0]['html'], 'Moldova');
                $this->assertContains('MULTIPOLYGON', $rec['children'][0]['the_geom']);
            }
        }
        
        $this->_unsetSelectable();
    }
    
}