<?php

class SearchControllerTest extends Giscuit_Test_PHPUnit_ControllerTestCase
{
    protected $_layerName = 'Worldboundaries';
    
    protected $_submitParamsEvery = array (
        'field' => 'name',
        'layer' => '',
        'text' => ' moldova',
        'where' => 'everywhere'
    );
    
    protected $_submitParamsZoned = array (
        'field' => 'name',
        'layer' => '',
        'text' => ' moldova',
        'where' => '25.780494,45.331642,30.999,48.627541'
    );
    
    protected function _getIdFromClass()
    {
        $layersTable = new Giscuit_Db_Table_Layers();                
        $row = $layersTable->getItems(array('whereClass' => $this->_layerName));
        foreach($row as $r) {
            $id = $r['id'];
        }        
        return $id;
    }
    
    public function testIndexAction()
    {
        $this->_testLoginActionSuccess();
        
        $this->dispatch('/' . $this->_language . '/tool/search');
        $this->assertModule('tool');
        $this->assertController('search');
        $this->assertAction('index');
        
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertContains('gtSearchForm', $response['form']);
    }
    
    public function testFieldsAction()
    {
        $this->_testLoginActionSuccess();
        
        $id = $this->_getIdFromClass();
        $this->dispatch('/' . $this->_language . '/tool/search/fields/layer_id/' . $id);
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        $this->assertEquals($response['replyCode'], 200);
        $this->assertEquals($response['defaultField'], $this->_submitParamsEvery['field']);
    }
    
    public function testSubmitActionEvery()
    {
        $this->_testLoginActionSuccess();

        $params = $this->_submitParamsEvery;
        $params['layer'] = $this->_getIdFromClass();
        
        $this->request->setMethod('POST')->setPost($params);
        $this->dispatch('/' . $this->_language . '/tool/search');
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        
        $this->assertEquals($response['replyCode'], 200);
        $this->assertEquals($response['records'][0]['iso_a2'], 'MD');
        $this->assertContains('MULTIPOLYGON',$response['records'][0]['the_geom']);
    }
    
    public function testSubmitActionZoned()
    {
        $this->_testLoginActionSuccess();
        
        $params = $this->_submitParamsZoned;
        $params['layer'] = $this->_getIdFromClass();

        $this->request->setMethod('POST')->setPost($params);
        $this->dispatch('/' . $this->_language . '/tool/search');
        $response = $this->getResponse()->getBody();
        $response = Zend_Json::decode($response);
        
        $this->assertEquals($response['replyCode'], 200);
        $this->assertEquals($response['records'][0]['iso_a2'], 'MD');
        $this->assertContains('MULTIPOLYGON', $response['records'][0]['the_geom']);
        
        $this->resetRequest()->resetResponse();
        $this->request->setPost(array());
    }
    
}